<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/backtrace-0.3.66/src/symbolize/gimli/libs_dl_iterate_phdr.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>libs_dl_iterate_phdr.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../../../storage.js"></script><script defer src="../../../../source-script.js"></script><script defer src="../../../../source-files.js"></script><script defer src="../../../../main.js"></script><noscript><link rel="stylesheet" href="../../../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../../../backtrace/index.html"><div class="logo-container"><img class="rust-logo" src="../../../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../../../backtrace/index.html"><div class="logo-container"><img class="rust-logo" src="../../../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../../../backtrace/index.html"><img class="rust-logo" src="../../../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
</pre><pre class="rust"><code><span class="comment">// Other Unix (e.g. Linux) platforms use ELF as an object file format</span>
<span class="comment">// and typically implement an API called `dl_iterate_phdr` to load</span>
<span class="comment">// native libraries.</span>

<span class="kw">use</span> <span class="ident"><span class="kw">super</span>::mystd::borrow::ToOwned</span>;
<span class="kw">use</span> <span class="ident"><span class="kw">super</span>::mystd::env</span>;
<span class="kw">use</span> <span class="ident"><span class="kw">super</span>::mystd::ffi</span>::{<span class="ident">CStr</span>, <span class="ident">OsStr</span>};
<span class="kw">use</span> <span class="ident"><span class="kw">super</span>::mystd::os::unix::prelude</span>::<span class="kw-2">*</span>;
<span class="kw">use</span> <span class="kw">super</span>::{<span class="ident">Library</span>, <span class="ident">LibrarySegment</span>, <span class="ident">OsString</span>, <span class="ident">Vec</span>};
<span class="kw">use</span> <span class="ident">core::slice</span>;

<span class="kw">pub</span>(<span class="kw">super</span>) <span class="kw">fn</span> <span class="ident">native_libraries</span>() -&gt; <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">Library</span><span class="op">&gt;</span> {
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">ret</span> <span class="op">=</span> <span class="ident">Vec::new</span>();
    <span class="kw">unsafe</span> {
        <span class="ident">libc::dl_iterate_phdr</span>(<span class="prelude-val">Some</span>(<span class="ident">callback</span>), <span class="kw-2">&amp;mut</span> <span class="ident">ret</span> <span class="kw">as</span> <span class="kw-2">*mut</span> <span class="ident">Vec</span><span class="op">&lt;</span><span class="kw">_</span><span class="op">&gt;</span> <span class="kw">as</span> <span class="kw-2">*mut</span> <span class="kw">_</span>);
    }
    <span class="kw">return</span> <span class="ident">ret</span>;
}

<span class="comment">// `info` should be a valid pointers.</span>
<span class="comment">// `vec` should be a valid pointer to a `std::Vec`.</span>
<span class="kw">unsafe</span> <span class="kw">extern</span> <span class="string">&quot;C&quot;</span> <span class="kw">fn</span> <span class="ident">callback</span>(
    <span class="ident">info</span>: <span class="kw-2">*mut</span> <span class="ident">libc::dl_phdr_info</span>,
    <span class="ident">_size</span>: <span class="ident">libc::size_t</span>,
    <span class="ident">vec</span>: <span class="kw-2">*mut</span> <span class="ident">libc::c_void</span>,
) -&gt; <span class="ident">libc::c_int</span> {
    <span class="kw">let</span> <span class="ident">info</span> <span class="op">=</span> <span class="kw-2">&amp;</span><span class="kw-2">*</span><span class="ident">info</span>;
    <span class="kw">let</span> <span class="ident">libs</span> <span class="op">=</span> <span class="kw-2">&amp;mut</span> <span class="kw-2">*</span>(<span class="ident">vec</span> <span class="kw">as</span> <span class="kw-2">*mut</span> <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">Library</span><span class="op">&gt;</span>);
    <span class="kw">let</span> <span class="ident">is_main_prog</span> <span class="op">=</span> <span class="ident">info</span>.<span class="ident">dlpi_name</span>.<span class="ident">is_null</span>() <span class="op">|</span><span class="op">|</span> <span class="kw-2">*</span><span class="ident">info</span>.<span class="ident">dlpi_name</span> <span class="op">==</span> <span class="number">0</span>;
    <span class="kw">let</span> <span class="ident">name</span> <span class="op">=</span> <span class="kw">if</span> <span class="ident">is_main_prog</span> {
        <span class="kw">if</span> <span class="ident">libs</span>.<span class="ident">is_empty</span>() {
            <span class="ident">env::current_exe</span>().<span class="ident">map</span>(<span class="op">|</span><span class="ident">e</span><span class="op">|</span> <span class="ident">e</span>.<span class="ident">into</span>()).<span class="ident">unwrap_or_default</span>()
        } <span class="kw">else</span> {
            <span class="ident">OsString::new</span>()
        }
    } <span class="kw">else</span> {
        <span class="kw">let</span> <span class="ident">bytes</span> <span class="op">=</span> <span class="ident">CStr::from_ptr</span>(<span class="ident">info</span>.<span class="ident">dlpi_name</span>).<span class="ident">to_bytes</span>();
        <span class="ident">OsStr::from_bytes</span>(<span class="ident">bytes</span>).<span class="ident">to_owned</span>()
    };
    <span class="kw">let</span> <span class="ident">headers</span> <span class="op">=</span> <span class="ident">slice::from_raw_parts</span>(<span class="ident">info</span>.<span class="ident">dlpi_phdr</span>, <span class="ident">info</span>.<span class="ident">dlpi_phnum</span> <span class="kw">as</span> <span class="ident">usize</span>);
    <span class="ident">libs</span>.<span class="ident">push</span>(<span class="ident">Library</span> {
        <span class="ident">name</span>,
        <span class="ident">segments</span>: <span class="ident">headers</span>
            .<span class="ident">iter</span>()
            .<span class="ident">map</span>(<span class="op">|</span><span class="ident">header</span><span class="op">|</span> <span class="ident">LibrarySegment</span> {
                <span class="ident">len</span>: (<span class="kw-2">*</span><span class="ident">header</span>).<span class="ident">p_memsz</span> <span class="kw">as</span> <span class="ident">usize</span>,
                <span class="ident">stated_virtual_memory_address</span>: (<span class="kw-2">*</span><span class="ident">header</span>).<span class="ident">p_vaddr</span> <span class="kw">as</span> <span class="ident">usize</span>,
            })
            .<span class="ident">collect</span>(),
        <span class="ident">bias</span>: <span class="ident">info</span>.<span class="ident">dlpi_addr</span> <span class="kw">as</span> <span class="ident">usize</span>,
    });
    <span class="number">0</span>
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../../../" data-current-crate="backtrace" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>